'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createAction = undefined;

var _rx = require('rx');

var _rx2 = _interopRequireDefault(_rx);

var _utils = require('../utils');

var _errors = require('../errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createObservable = function createObservable(subject, cb) {
  if (typeof cb === 'function') {
    return cb(subject.asObservable());
  } else {
    return subject.asObservable();
  }
};

var createAction = exports.createAction = function createAction(cb) {
  var subject = new _rx2.default.Subject();
  var observable = createObservable(subject, cb);
  if (!(0, _utils.isObservable)(observable)) {
    (0, _errors.throwActionObservableError)();
  }
  var sharedObservable = observable.share();
  var action = function action(e) {
    var nextVal = typeof e === 'undefined' ? null : e;
    subject.onNext(nextVal);
  };
  return Object.assign(action, { asObservable: function asObservable() {
      return sharedObservable;
    } });
};