'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pick = exports.getObservable = exports.isSubject = exports.isObservable = exports.isObject = exports.isPlainObject = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _rx = require('rx');

var _rx2 = _interopRequireDefault(_rx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPlainObject = exports.isPlainObject = function isPlainObject(value) {
  return isObject(value) && !isObservable(value);
};

var isObject = exports.isObject = function isObject(value) {
  return (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value !== null && !Array.isArray(value);
};

var isObservable = exports.isObservable = function isObservable(value) {
  return value instanceof _rx2.default.Observable || isSubject(value);
};

var isSubject = exports.isSubject = function isSubject(value) {
  return !![_rx2.default.Subject, _rx2.default.BehaviorSubject, _rx2.default.ReplaySubject, _rx2.default.AsyncSubject].find(function (c) {
    return value instanceof c;
  });
};

var getObservable = exports.getObservable = function getObservable(value) {
  if (isObservable(value)) {
    return value;
  } else if (typeof value.asObservable === 'function') {
    return value.asObservable();
  } else {
    throw new TypeError('Invalid Observable');
  }
};

var pick = exports.pick = function pick(obj, keys) {
  return keys.reduce(function (acc, key) {
    acc[key] = obj[key];
    return acc;
  }, {});
};